using System;

/// <summary>
/// Luento 10. Arvopohjaiset ja viitepohjaiset muuttujat
/// </summary>
public class ArvotJaViitteet
{
    /// <summary>
    /// Arvopohjaiset ja viitepohjaiset muuttujat
    /// </summary>
    public static void Main()
    {
        int[] taulukko1 = { 1, 2, 3 };
        //Console.WriteLine(taulukko1);
        int[] taulukko2 = taulukko1;
        taulukko2[1] = 4;
        
        // Tätä ei nähty luennolla. Tarkoitus oli näyttää tämä, mutta unohdin. 
        // Sama tehtiin Pythonissa ja ajatus oli näyttää, että 
        // viite- ja arvopohjaisten muuttujien idea on hyvin samantapainen eri kielissä. 
        Console.WriteLine($"Eka alkio nyt: {taulukko1[0]}");
        Muuta(taulukko1);
        Console.WriteLine($"Eka alkio Muuta-funktion kutsumisen jälkeen: {taulukko1[0]}");

        int a = 3;
        Console.WriteLine($"Arvopohjainen muuttuja aluksi: {a}");
        Muuta(a);
        Console.WriteLine($"Arvopohjainen muuttuja Muuta-funktion kutsumisen jälkeen: {a}");
    }

    public static void Muuta(int luku)
    {
        luku = 1000;
    }

    public static void Muuta(int[] t)
    {
        t[0] = 1000;
    }
}